--[[
Addon Description:
1.0b: Capable of checking Fort, Kings, Int, Spirit, Class Buff (need to add warlock),
	Shadow Prot, Flasks, Well Fed Buff (need to implement more in depth check if possible)
	Capable of checking in raid sizes with default command of 10 or 25, (scales to amount
	of people in raid if less then given raid size, scales to the raidsize if larger than
	given raid size).  By nature of raiding the first 10/25 people are scanned for buffs.
--]]


--[[
Slash command message handling:
	Builds and prints the information to be displayed by the helper functions.
	Helper functions build the required string to be printed, while this main body function
		adds titles and other checks to the commands to ensure the appropriate information
		is gathered for the command given
	Commands included are /rsc, /raidstatcheck, and /raidstatuschecker
	All of these are equal commands and are just for use of user preference
	Follow up commands include: 
		an emptry string which prints version information
		help which prints information in regards to operate the basic functionality of the addon
		10 or 25 which does the appropriate raid check for the 2 different sizes of raids
	
--]]
function RaidStatusChecker_SlashCommandHandler(msg)
	local RSC_channel = "";
	local RSC_raidsize = 0;
	local RSC_annoTitle = "Raid Status Check";
	local RSC_fortTitle = "<< Missing Fort >>";
	local RSC_kingTitle = "<< Missing Kings >>";
	local RSC_inteTitle = "<< Missing Intellect >>";
	local RSC_spirTitle = "<< Missing Spirit >>";
	local RSC_shadTitle = "<< Missing Shadow >>";
	local RSC_clasTitle = "<< Missing Class Self Buff >>";
	local RSC_flasTitle = "<< Missing Flask or 2 Elixirs >>";
	local RSC_foodTitle = "<< Missing Well Fed >>";
	
	
	if msg == "" then
		DEFAULT_CHAT_FRAME:AddMessage(RSC_version());
	elseif msg == "help" then
		DEFAULT_CHAT_FRAME:AddMessage(RSC_help());
	elseif msg == "10" and GetNumRaidMembers() > 0 then
		if(GetNumRaidMembers() > 10) then
			RSC_raidsize = 10;
		else
			RSC_raidsize = GetNumRaidMembers();
		end
		
		RSC_channel = "RAID";
		
		SendChatMessage(RSC_annoTitle, RSC_channel);
		SendChatMessage(RSC_fortTitle, RSC_channel);
		SendChatMessage(RSC_buildFort(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_kingTitle, RSC_channel);		
		SendChatMessage(RSC_buildKing(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_inteTitle, RSC_channel);		
		SendChatMessage(RSC_buildInte(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_spirTitle, RSC_channel);		
		SendChatMessage(RSC_buildSpir(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_shadTitle, RSC_channel);		
		SendChatMessage(RSC_buildShad(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_clasTitle, RSC_channel);
		SendChatMessage(RSC_buildClas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_flasTitle, RSC_channel);
		SendChatMessage(RSC_buildFlas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_foodTitle, RSC_channel);
		SendChatMessage(RSC_buildFood(RSC_raidsize), RSC_channel);
	elseif msg == "15" and GetNumRaidMembers() > 0 then
		if(GetNumRaidMembers() > 15) then
			RSC_raidsize = 15;
		else
			RSC_raidsize = GetNumRaidMembers();
		end
		
		RSC_channel = "RAID";
		
		SendChatMessage(RSC_annoTitle, RSC_channel);
		SendChatMessage(RSC_fortTitle, RSC_channel);
		SendChatMessage(RSC_buildFort(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_kingTitle, RSC_channel);		
		SendChatMessage(RSC_buildKing(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_inteTitle, RSC_channel);		
		SendChatMessage(RSC_buildInte(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_spirTitle, RSC_channel);		
		SendChatMessage(RSC_buildSpir(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_shadTitle, RSC_channel);		
		SendChatMessage(RSC_buildShad(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_clasTitle, RSC_channel);
		SendChatMessage(RSC_buildClas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_flasTitle, RSC_channel);
		SendChatMessage(RSC_buildFlas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_foodTitle, RSC_channel);
		SendChatMessage(RSC_buildFood(RSC_raidsize), RSC_channel);
	elseif msg == "25" and GetNumRaidMembers() > 0 then
		if(GetNumRaidMembers() > 25) then
			RSC_raidsize = 25;
		else
			RSC_raidsize = GetNumRaidMembers();
		end
		
		RSC_channel = "RAID";
		
		SendChatMessage(RSC_annoTitle, RSC_channel);
		SendChatMessage(RSC_fortTitle, RSC_channel);
		SendChatMessage(RSC_buildFort(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_kingTitle, RSC_channel);		
		SendChatMessage(RSC_buildKing(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_inteTitle, RSC_channel);		
		SendChatMessage(RSC_buildInte(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_spirTitle, RSC_channel);		
		SendChatMessage(RSC_buildSpir(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_shadTitle, RSC_channel);		
		SendChatMessage(RSC_buildShad(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_clasTitle, RSC_channel);
		SendChatMessage(RSC_buildClas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_flasTitle, RSC_channel);
		SendChatMessage(RSC_buildFlas(RSC_raidsize), RSC_channel);
		
		SendChatMessage(RSC_foodTitle, RSC_channel);
		SendChatMessage(RSC_buildFood(RSC_raidsize), RSC_channel);
	else
		DEFAULT_CHAT_FRAME:AddMessage(RSC_notInRaid(), 1.0, 0.0, 0.0);
	end
end

function RaidStatusChecker_OnLoad()
	SlashCmdList["RAIDSTATUSCHECKER"] = RaidStatusChecker_SlashCommandHandler;
	SLASH_RAIDSTATUSCHECKER1 = "/rsc";
	SLASH_RAIDSTATUSCHECKER2 = "/raidstatcheck";
	SLASH_RAIDSTATUSCHECKER3 = "/raidstatuschecker";
end

function RSC_version()
	return "1.1b";
end

function RSC_help()
	help = "Raid Status Checker Help\n" ..
		"/rsc for version info\n" ..
		"/rsc 10 for a 10 man raid status check\n" ..
		"/rsc 25 for a 25 man raid status check";
	return help;
end

function RSC_notInRaid()
	return "Not in a Raid Group, Convert to raid to use RSC"
end

--Used in correlation with the maxStringLength function to limit spam
function RSC_manyMissingBuff()
	return "Many Missing Buff!";
end

--Function to determine the limit of string length (can elimite spam of names from addon)
function RSC_maxStringLength()
	return 150;
end

--Function to use WoW API and gather the needed spell name for a given spell id
function RSC_SpellName(RSC_spellID)
	RSC_spellName = GetSpellInfo(RSC_spellID);
	return RSC_spellName;
end

--[[
	The next block of tables are used simply to maintain a list of current and
		up to date spells and abilities for the respective checks needed to ensure
		the most prepared raid.
--]]
RSC_flasks = {
	RSC_SpellName(79469), -- Flask of Steelskin (Stamina)
	RSC_SpellName(79470), -- Flask of the Draconic Mind (Intellect)
	RSC_SpellName(79471), -- Flask of the Winds (Agility)
	RSC_SpellName(79472), -- Flask of Titanic Strength (Strength)
	RSC_SpellName(94160), -- Flask of Flowing Water (Spirit)
}

RSC_belixirs = {	
	RSC_SpellName(79477), -- Elixir of the Cobra (Crit)
	RSC_SpellName(79481), -- Elixir of Impossible Accuracy (Hit)
	RSC_SpellName(79632), -- Elixir of Mighty Speed (Haste)
	RSC_SpellName(79635), -- Elixir of the Master (Mastery)
	RSC_SpellName(79468), -- Ghost Elixir (Spirit)
}

RSC_gelixirs = {	
	RSC_SpellName(79474), -- Elixir of the Naga (Expertise)
	RSC_SpellName(79480), -- Elixir of Deep Earth (Armor)
	RSC_SpellName(79631), -- Prismatic Elixir (Resist)
}

RSC_food = {
	RSC_SpellName(87551), -- Baked Rockfish (Crit)
	RSC_SpellName(87552), -- Basilisk Liverdog (Haste)
	RSC_SpellName(87545), -- Beer-Bated Crocolisk (Strength)
	RSC_SpellName(87555), -- Blackbelly Sushi (Parry)
	RSC_SpellName(87635), -- Cocolisk Au Gratin (Expertise)
	RSC_SpellName(87648), -- Delicious Sagefish Tail (Spirit)
	RSC_SpellName(87550), -- Grilled Dragon (Hit)
	RSC_SpellName(87549), -- Lavasclae Minestrone (Mastery)
	RSC_SpellName(87554), -- Mushroom Sauce Mudfish (Dodge)
	RSC_SpellName(87547), -- Severed Sagefish Head (Intellect)
	RSC_SpellName(87546), -- Skewed Eel (Agility)
}

RSC_fortitude = {
	RSC_SpellName(21562), -- Prayer of Fortitude
	RSC_SpellName(6307), -- Blood Pact
	RSC_SpellName(469), --Commanding Shout
}

RSC_kings = {
	RSC_SpellName(1126), -- Mark of the Wild
	RSC_SpellName(20217), -- Blessing of Kings
}

RSC_intellect = {
	RSC_SpellName(1459), -- Arcane Intellect
	RSC_SpellName(61316), -- Dalaran Brilliance
}

RSC_spirit = {
	RSC_SpellName(14752), -- Divine Spirit
	RSC_SpellName(27681), -- Prayer of Spirit
}

RSC_shadow = {
	RSC_SpellName(27683), -- Prayer of Shadow Protection
}

RSC_blessingofwisdom = {
	RSC_SpellName(54424), -- Fel Intellect
	RSC_SpellName(5675), -- Mana Spring
	RSC_SpellName(19740), -- Blessing of Might
}

RSC_blessingofmight = {
	RSC_SpellName(30808), -- Unleashed Rage
	RSC_SpellName(53138), -- Abomination's Might
	RSC_SpellName(19740), -- Blessing of Might
	RSC_SpellName(19506), -- Trueshot Aura
}

RSC_magearmors = {
	RSC_SpellName(6117), -- Mage Armor
	RSC_SpellName(7302), -- Frost Armor
	RSC_SpellName(30482), -- Molten Armor
}

RSC_dkpresences = {
	RSC_SpellName(48266), -- Blood Presence
	RSC_SpellName(48263), -- Frost Presence
	RSC_SpellName(48265), -- Unholy Presence
}

RSC_seals = {
	RSC_SpellName(20165), -- Seal of Insight
	RSC_SpellName(20164), -- Seal of Justice
	RSC_SpellName(31801), -- Seal of Truth
	RSC_SpellName(20154), -- Seal of Righteousness	
}

RSC_lockarmors = {
	RSC_SpellName(28176), -- Fel Armor
	RSC_SpellName(687), -- Demon Armor
}

RSC_auras = {
	RSC_SpellName(465), -- Devotion Aura
	RSC_SpellName(19891), -- Resistance Aura
	RSC_SpellName(19746), -- Concentration Aura
	RSC_SpellName(7294), -- Retribution Aura
}


--[[
	The next block of functions checks each buff division that is needed for a
		fully ready raid.
	It returns a blank string if all checks are passes, but returns the characters
		name if a check is failed.
	These are the third tier of functions and are the meat and bones of the addon
		this is all the user trully cares about, but printing all the information
		to make it more readily available for the user is the important part.
--]]
function RSC_checkflasks(RSC_charName)
	local RSC_fbuffed = false;
	local RSC_bbuffed = false;
	local RSC_gbuffed = false;
	
	for i = 1, table.getn(RSC_flasks) do
	 RSC_flaskbuff = UnitBuff(RSC_charName, RSC_flasks[i]);
	 if RSC_flaskbuff == RSC_flasks[i] then
		RSC_fbuffed = true;
		break
	 end
	end
	
	for i = 1, table.getn(RSC_belixirs) do
	 RSC_belixirbuff = UnitBuff(RSC_charName, RSC_belixirs[i]);
	 if RSC_belixirbuff == RSC_belixirs[i] then
		RSC_bbuffed = true;
		break
	 end
	end
	
	for i = 1, table.getn(RSC_gelixirs) do
	 RSC_gelixirbuff = UnitBuff(RSC_charName, RSC_gelixirs[i]);
	 if RSC_gelixirbuff == RSC_gelixirs[i] then
		RSC_gbuffed = true;
		break
	 end
	end
	
	if (not RSC_fbuffed) or (not RSC_bbuffed and not RSC_gbuffed) then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkfood(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_food) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_food[i])
	 if RSC_buff == RSC_food[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkfortitude(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_fortitude) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_fortitude[i])
	 if RSC_buff == RSC_fortitude[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkkings(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_kings) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_kings[i])
	 if RSC_buff == RSC_kings[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkintellect(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_intellect) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_intellect[i])
	 if RSC_buff == RSC_intellect[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkspirit(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_spirit) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_spirit[i])
	 if RSC_buff == RSC_spirit[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkshadow(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_shadow) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_shadow[i])
	 if RSC_buff == RSC_shadow[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkclasses(RSC_charName)
	local RSC_thisclass = UnitClass(RSC_charName);
	local RSC_buffed = false;
	if RSC_thisclass == "Paladin" then
		for i = 1, table.getn(RSC_seals) do
			RSC_buff = UnitBuff(RSC_charName, RSC_seals[i]);
			if RSC_buff == RSC_seals[i] then
				RSC_buffed = true
			end
		end
	elseif RSC_thisclass == "Deathknight" then
		for i = 1, table.getn(RSC_dkpresences) do
			RSC_buff = UnitBuff(RSC_charName, RSC_dkpresences[i]);
			if RSC_buff == RSC_dkpresences[i] then
				RSC_buffed = true;
			end
		end
	elseif RSC_thisclass == "Mage" then
		for i = 1, table.getn(RSC_magearmors) do
			RSC_buff = UnitBuff(RSC_charName, RSC_magearmors[i]);
			if RSC_buff == RSC_magearmors[i] then
				RSC_buffed = true;
			end
		end
	elseif RSC_thisclass == "Warlock" then
		for i = 1, table.getn(RSC_lockarmors) do
			RSC_buff = UnitBuff(RSC_charName, RSC_lockarmors[i]);
			if RSC_buff == RSC_lockarmors[i] then
				RSC_buffed = true;
			end
		end
	else
		RSC_buffed = true;
	end
	
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkmight(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_food) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_blessingofmight[i])
	 if RSC_buff == RSC_blessingofmight[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end

function RSC_checkwisdom(RSC_charName)
	local RSC_buffed = false;
	for i = 1, table.getn(RSC_food) do
	 RSC_buff = UnitBuff(RSC_charName, RSC_blessingofwisdom[i])
	 if RSC_buff == RSC_blessingofwisdom[i] then
		RSC_buffed = true;
		break
	 end
	end
	if not RSC_buffed then
		return RSC_charName;
	else
		return "";
	end
end


--[[
	The next block of functions take the respective check functions and build
		the string of character names who have failed the buff check.
		(In other words, accumulates all the character names who are not buffed)
	These functions are called by the main body function that is the rsc
		command handler.  These functions are essentially the 2nd tier of functions
		that make the information more readily available for the user.
--]]
function RSC_buildFlas(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkflasks(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildFood(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkfood(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildFort(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkfortitude(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildKing(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkkings(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildInte(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkintellect(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildSpir(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkspirit(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildShad(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkshadow(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end

function RSC_buildClas(RSC_raidsizeIn)
	local RSC_buffCheck = "";
	local RSC_characterTemp = "";
	local RSC_tempString = "";
	
	for i = 1,RSC_raidsizeIn,1 do 
		RSC_characterTemp = GetRaidRosterInfo(i);
		RSC_tempString = RSC_checkclasses(RSC_characterTemp);
		if RSC_tempString ~= "" then
			RSC_buffCheck = RSC_buffCheck .. RSC_tempString;
			RSC_buffCheck = RSC_buffCheck .. ", ";
		end
	end
	
	if string.len(RSC_buffCheck) < RSC_maxStringLength() then
		return RSC_buffCheck;
	else
		return RSC_manyMissingBuff();
	end
end